# GridImageryProvider

#### new Cesium.GridImageryProvider(options, backgroundColor)
Scene/GridImageryProvider.js 45

  An `ImageryProvider` that draws a wireframe grid on every tile with controllable background and glow. May be useful for custom rendering effects or debugging terrain.

  Name | Type | Default | Description
  --- | --- | --- | ---

  `options`

  Object

  optional Object with the following properties:

  Name | Type | Default | Description
  --- | --- | --- | ---
  `tilingScheme` | TilingScheme | `new GeographicTilingScheme()` | optional The tiling scheme for which to draw tiles.
  `ellipsoid` | Ellipsoid |  | optional The ellipsoid. If the tilingScheme is specified, this parameter is ignored and the tiling scheme's ellipsoid is used instead. If neither parameter is specified, the WGS84 ellipsoid is used.
  `cells` | Number | `8` | optional The number of grids cells.
  `color` | Color | `Color(1.0, 1.0, 1.0, 0.4)` | optional The color to draw grid lines.
  `glowColor` | Color | `Color(0.0, 1.0, 0.0, 0.05)` | optional The color to draw glow for grid lines.
  `glowWidth` | Number | `6` | optional The width of lines used for rendering the line glow effect.

  `backgroundColor` | Color | `Color(0.0, 0.5, 0.0, 0.2)` | optional Background fill color.
  `options.tileWidth` | Number | `256` | optional The width of the tile for level-of-detail selection purposes.
  `options.tileHeight` | Number | `256` | optional The height of the tile for level-of-detail selection purposes.
  `options.canvasSize` | Number | `256` | optional The size of the canvas used for rendering.

### Members

#### readonlycredit : Credit
Scene/GridImageryProvider.js 220

  Gets the credit to display when this imagery provider is active. Typically this is used to credit the source of the imagery. This function should not be called before `GridImageryProvider#ready` returns true.

#### readonlyerrorEvent : Event
Scene/GridImageryProvider.js 183

  Gets an event that is raised when the imagery provider encounters an asynchronous error. By subscribing to the event, you will be notified of the error and can potentially recover from it. Event listeners are passed an instance of `TileProviderError`.

#### readonlyhasAlphaChannel : Boolean
Scene/GridImageryProvider.js 236

  Gets a value indicating whether or not the images provided by this imagery provider include an alpha channel. If this property is false, an alpha channel, if present, will be ignored. If this property is true, any images without an alpha channel will be treated as if their alpha is 1.0 everywhere. When this property is false, memory usage and texture upload time are reduced.

#### readonlymaximumLevel : Number
Scene/GridImageryProvider.js 115

  Gets the maximum level-of-detail that can be requested. This function should not be called before `GridImageryProvider#ready` returns true.

#### readonlyminimumLevel : Number
Scene/GridImageryProvider.js 128

  Gets the minimum level-of-detail that can be requested. This function should not be called before `GridImageryProvider#ready` returns true.

#### readonlyproxy : Proxy
Scene/GridImageryProvider.js 76

  Gets the proxy used by this provider.

#### readonlyready : Boolean
Scene/GridImageryProvider.js 195

  Gets a value indicating whether or not the provider is ready for use.

#### readonlyreadyPromise : Promise.<Boolean>
Scene/GridImageryProvider.js 207

  Gets a promise that resolves to true when the provider is ready for use.

#### readonlyrectangle : Rectangle
Scene/GridImageryProvider.js 154

  Gets the rectangle, in radians, of the imagery provided by this instance. This function should not be called before `GridImageryProvider#ready` returns true.

#### readonlytileDiscardPolicy : TileDiscardPolicy
Scene/GridImageryProvider.js 169

  Gets the tile discard policy. If not undefined, the discard policy is responsible for filtering out "missing" tiles via its shouldDiscardImage function. If this function returns undefined, no tiles are filtered. This function should not be called before `GridImageryProvider#ready` returns true.

#### readonlytileHeight : Number
Scene/GridImageryProvider.js 102

  Gets the height of each tile, in pixels. This function should not be called before `GridImageryProvider#ready` returns true.

#### readonlytileWidth : Number
Scene/GridImageryProvider.js 89

  Gets the width of each tile, in pixels. This function should not be called before `GridImageryProvider#ready` returns true.

#### readonlytilingScheme : TilingScheme
Scene/GridImageryProvider.js 141

  Gets the tiling scheme used by this provider. This function should not be called before `GridImageryProvider#ready` returns true.

### Methods

#### _createGridCanvas()
Scene/GridImageryProvider.js 264

  Render a grid into a canvas with background and glow

#### _drawGrid()
Scene/GridImageryProvider.js 246

  Draws a grid of lines into a canvas.

#### getTileCredits(x, y, level) → Array.<Credit>
Scene/GridImageryProvider.js 313

  Gets the credits to be displayed when a given tile is displayed.

  Name | Type | Description
  --- | --- | ---
  `x` | Number | The tile X coordinate.
  `y` | Number | The tile Y coordinate.
  `level` | Number | The tile level;

  ##### Returns:

  The credits to be displayed when the tile is displayed.

  ##### Throws:

  - DeveloperError : `getTileCredits` must not be called before the imagery provider is ready.

#### pickFeatures(x, y, level, longitude, latitude) → Promise.<Array.<ImageryLayerFeatureInfo>>|undefined
Scene/GridImageryProvider.js 347

  Picking features is not currently supported by this imagery provider, so this function simply returns undefined.

  Name | Type | Description
  --- | --- | ---
  `x` | Number | The tile X coordinate.
  `y` | Number | The tile Y coordinate.
  `level` | Number | The tile level.
  `longitude` | Number | The longitude at which to pick features.
  `latitude` | Number | The latitude at which to pick features.

  ##### Returns:

  A promise for the picked features that will resolve when the asynchronous picking completes. The resolved value is an array of `ImageryLayerFeatureInfo` instances. The array may be empty if no features are found at the given location. It may also be undefined if picking is not supported.

#### requestImage(x, y, level) → Promise.<(Image|Canvas)>|undefined
Scene/GridImageryProvider.js 329

  Requests the image for a given tile. This function should not be called before `GridImageryProvider#ready` returns true.

  Name | Type | Description
  --- | --- | ---
  `x` | Number | The tile X coordinate.
  `y` | Number | The tile Y coordinate.
  `level` | Number | The tile level.

  ##### Returns:

  A promise for the image that will resolve when the image is available, or undefined if there are too many active requests to the server, and the request should be retried later. The resolved image may be either an Image or a Canvas DOM object.